#%% begin initialize drupal-7.8-noarch-P1
###################################################################
export LANG=C
export PATH=/bin:/usr/bin:/sbin:/usr/sbin

if [ -r /tmp/SeTT_PX ]; then
    ROOT="`cat /tmp/SeTT_PX`"
fi

APACI_DIR=$ROOT/opt/httpd
PG_DIR=$ROOT/opt/pgsql
WWW=$ROOT/home/www
export PGLIB=$PG_DIR/lib
export PGDATA=$PG_DIR/data

if [ -f $ROOT/opt/htdocs/drupal7 ]; then
    /bin/mv  $ROOT/opt/htdocs/drupal7  $ROOT/opt/htdocs/drupal7.bak
fi

if [ -f $ROOT/opt/htdocs/drupal7.bak/sites/default/settings.php ]; then
    # update for minor release(security fix and so on)
    /bin/cp -p $ROOT/opt/htdocs/drupal7.bak/sites/default/settings.php \
	       $ROOT/opt/htdocs/drupal-7.8/sites/default/settings.php
    (cd $ROOT/opt/htdocs/drupal7.bak/;
	for i in `find sites/all/themes/ -mindepth 1 -maxdepth 1 -type d`; do \
	    if [ ! -d $ROOT/opt/htdocs/drupal-7.8/$i ]; then
		echo "copying $i ..."
		/bin/cp -a $i $ROOT/opt/htdocs/drupal-7.8/$i
	    fi
	done
	for i in `find sites/all/modules/ -mindepth 1 -maxdepth 1 -type d`; do \
	    if [ ! -d $ROOT/opt/htdocs/drupal-7.8/$i ]; then
		echo "copying $i ..."
		/bin/cp -a $i $ROOT/opt/htdocs/drupal-7.8/$i
	    fi
	done
	)
    /usr/bin/tar cf - -C $ROOT/opt/htdocs/drupal7.bak/ files | /usr/bin/tar xf - -C $ROOT/opt/htdocs/drupal-7.8/
    /bin/rm -f $ROOT/opt/htdocs/drupal-7.8/install.php
    /bin/chmod go-w  /opt/htdocs/drupal-7.8/sites/default/
else
    # newly install
    FQDN=`hostname -f`
    if [ ".$FQDN" = "." ]; then
	FQDN=localhost
    fi
    
    if [ -f $ROOT/opt/htdocs/drupal-7.8/sites/default/settings.php ]; then
	/bin/mv $ROOT/opt/htdocs/drupal-7.8/sites/default/settings.php \
	        $ROOT/opt/htdocs/drupal-7.8/sites/default/settings.php.bak
    fi
    /usr/bin/sed \
	-e "/\$databases = array();/a \$databases['default']['default'] = array(\n\ \ 'driver' => 'pgsql',\n\ \ 'database' => 'drupal7',\n\ \ 'username' => 'www',\n\ \ 'password' => 'pass',\n\ \ 'host' => '127.0.0.1',\n\ \ 'prefix' => '',\n\);" \
	-e "/# \$base_url = 'http:\/\/www.example.com';/a \$base_url = 'http://$FQDN/drupal7';" \
	$ROOT/opt/htdocs/drupal-7.8/sites/default/default.settings.php \
	> $ROOT/opt/htdocs/drupal-7.8/sites/default/settings.php

    /bin/chown www:apache \
	$ROOT/opt/htdocs/drupal-7.8/sites/default/settings.php 
    /bin/chmod 640 \
	$ROOT/opt/htdocs/drupal-7.8/sites/default/settings.php 
    
    /bin/mkdir -p $ROOT/opt/htdocs/drupal-7.8/files
    /bin/mkdir -p $ROOT/opt/htdocs/drupal-7.8/sites/default/files
    /bin/cp $ROOT/opt/htdocs/drupal-7.8/custom/_htaccess $ROOT/opt/htdocs/drupal-7.8/.htaccess
    /bin/chown www:apache $ROOT/opt/htdocs/drupal-7.8/files \
			$ROOT/opt/htdocs/drupal-7.8/sites/default/files \
			$ROOT/opt/htdocs/drupal-7.8/sites/all/ \
			$ROOT/opt/htdocs/drupal-7.8/.htaccess 
    /bin/chmod 640 $ROOT/opt/htdocs/drupal-7.8/files \
			$ROOT/opt/htdocs/drupal-7.8/.htaccess
fi
(cd $ROOT/opt/htdocs; /bin/rm -f drupal7; /bin/ln -sf drupal-7.8 drupal7 )
(cd $ROOT/usr/bin; /bin/rm -f drush; /bin/ln -sf ../share/drush/drush drush )

# this script check db existance itself.
/bin/su - postgres -c "sh $ROOT/opt/htdocs/drupal7/custom/create_drupal7_db84"

PGRE=0
if [ -f $PG_DIR/data/postgresql.conf ]; then
  if ! egrep "^default_text_search_config = 'pg_catalog.japanese'" $PG_DIR/data/postgresql.conf 1>/dev/null 2>&1; then
    /bin/mv $PG_DIR/data/postgresql.conf $PG_DIR/data/postgresql.conf.bak
    /usr/bin/sed -e "/^default_text_search_config/a default_text_search_config = \'pg_catalog.japanese\'" \
              -e 's/^\(default_text_search_config.*\)/;\1/' \
    $PG_DIR/data/postgresql.conf.bak >  $PG_DIR/data/postgresql.conf
    /bin/chown -R www.apache  $PG_DIR/data/postgresql.conf
    PGRE=1
  fi
fi
if [ -f $PG_DIR/data/pg_hba.conf ]; then
  if ! egrep "^host	drupal7		www" $PG_DIR/data/pg_hba.conf 1>/dev/null 2>&1; then
    /bin/cp -p $PG_DIR/data/pg_hba.conf $PG_DIR/data/pg_hba.conf.bak
    /usr/bin/sed -e "/^# Allow user access to the all database on localhost/a host	drupal7		www	127.0.0.1/32	trust" $PG_DIR/data/pg_hba.conf.bak > $PG_DIR/data/pg_hba.conf
    PGRE=1
  fi
fi

if [ $PGRE = 1 ]; then
  if [ -x /opt/pgsql/bin/pgsqld ]; then
    /opt/pgsql/bin/pgsqld restart
  fi
fi

if [ ! -f $WWW/.postgresql/postgresql.crt ]; then
    /bin/mkdir -p $WWW/.postgresql
    /bin/cp $PG_DIR/data/server.crt $WWW/.postgresql/postgresql.crt
    /bin/cp $PG_DIR/data/server.key $WWW/.postgresql/postgresql.key
    /bin/chown -R www.apache  $WWW/.postgresql
fi

/bin/mkdir -p            $ROOT/opt/htdocs/drupal7/files
/bin/chown -R www.apache $ROOT/opt/htdocs/drupal7/files \
	                 $ROOT/opt/htdocs/drupal7/themes
/bin/chgrp -R apache     $ROOT/opt/htdocs/drupal7

if ! fgrep "drupal7/cron.php" $ROOT/var/spool/cron/crontabs/www 1>/dev/null 2>&1; then
    echo "0  *  *  *  *	/usr/bin/wget -O - -q http://$FQDN/drupal7/cron.php" >> $ROOT/var/spool/cron/crontabs/www
fi

#%% end
